#ifndef SKIPPERSV2_H_
#define SKIPPERSV2_H_

/*フライトモードの変数================
    ModeBreak       モードブレイク         状態変更時に１回だけ呼び出して、現在実行中のRTOSタスクを全部無効にする
    GroundCheck     初期化モード          まず最初に呼び出して、各種設定を有効にし、機体のチェック等を行う
    ManualMode      手動飛行モード         通常のラジコンと同じ状態
    AutoLoop        自動操縦　水平旋回モード
    AutoMobius      自動操縦　８の字飛行モード
    AutoClimb       自動操縦　上昇旋回
    AutoGlide       自動操縦　自動滑空
    AutoLanding     自動操縦　自動着陸
*/
    #define GROUNDCHECK 0
    #define MANUALMODE  1
    #define AUTOLOOP    2
    #define AUTOMOBIUS  3
    #define AUTOCLIMB   4
    #define AUTOGLIDE   5
    #define AUTOLANDING 6
    
    #define MAGBIASX -144   //-63
    #define MAGBIASY 480   //580
    #define MAGBIASZ 125   //132

int OperationMode=GROUNDCHECK;    //通常時 
//int OperationMode=2;             //デバック用

bool Flag_ChangeMode=true;      //モードを切り替えた瞬間を検出してtrueを返す　モード変更が直ちに行われ、falseになる。
//=========== end =============

#endif /* SKIPPERSV2_H_ */